#ifndef TouchBtn_h
#define TouchBtn_h
#include <util/delay.h>
#include <millis.h>

//define functions for bit manipulation
#define set(dir,pin) (dir |= pin)
#define clear(dir,pin) (dir &= (~pin))
#define settle_delay() _delay_us(50) // settle delay

class TouchBtn
{
    public:
        void begin(int touch_threshold, uint8_t debounce_ms);
        void calibrate();
        uint16_t read();
        bool pressed();
        uint16_t thershold;
        TouchBtn(volatile uint8_t *tx_port,volatile uint8_t *tx_dir,uint8_t tx_pin,uint8_t rx_channel);
    private:
        bool has_changed();
        volatile uint8_t *_tx_port;
        volatile uint8_t *_tx_dir;
        uint8_t _tx_pin;
        uint8_t _channel;
        float filt;
        float eps;
        bool _state;
        bool _has_changed;
        uint8_t _debounce_ms;
        uint16_t _ignore_until;
        int _touch_threshold;
};
#endif